searchNodes=[{"ref":"GenQueue.Adapters.Oban.html","title":"GenQueue.Adapters.Oban","type":"module","doc":"An adapter for GenQueue to enable functionality with Oban."},{"ref":"GenQueue.Adapters.Oban.html#handle_job/2","title":"GenQueue.Adapters.Oban.handle_job/2","type":"function","doc":"Push a GenQueue.Job for Oban to consume. Parameters: gen_queue - A GenQueue module job - A GenQueue.Job Returns: {:ok, job} if the operation was successful {:error, reason} if there was an error"},{"ref":"GenQueue.Adapters.Oban.html#handle_push/3","title":"GenQueue.Adapters.Oban.handle_push/3","type":"function","doc":"Callback implementation for GenQueue.Adapter.push/2"},{"ref":"readme.html","title":"GenQueue Oban","type":"extras","doc":"GenQueue Oban This is an adapter for GenQueue to enable functionality with Oban."},{"ref":"readme.html#installation","title":"GenQueue Oban - Installation","type":"extras","doc":"The package can be installed by adding gen_queue_oban to your list of dependencies in mix.exs: def deps do [ {:gen_queue_oban, &quot;~&gt; 0.1.0&quot;} ] end"},{"ref":"readme.html#documentation","title":"GenQueue Oban - Documentation","type":"extras","doc":"See HexDocs for additional documentation."},{"ref":"readme.html#configuration","title":"GenQueue Oban - Configuration","type":"extras","doc":"Before starting, please refer to the Oban documentation for details on configuration. This adapter handles zero Oban related config."},{"ref":"readme.html#creating-enqueuers","title":"GenQueue Oban - Creating Enqueuers","type":"extras","doc":"We can start off by creating a new GenQueue module, which we will use to push jobs to Oban. defmodule Enqueuer do use GenQueue, otp_app: :my_app end Once we have our module setup, ensure we have our config pointing to the GenQueue.Adapters.Oban adapter. config :my_app, Enqueuer, [ adapter: GenQueue.Adapters.Oban ]"},{"ref":"readme.html#starting-enqueuers","title":"GenQueue Oban - Starting Enqueuers","type":"extras","doc":"By default, gen_queue_oban does not start Oban on application start. So we must add our new Enqueuer module to our supervision tree. children = [ supervisor(Enqueuer, []), ]"},{"ref":"readme.html#creating-jobs","title":"GenQueue Oban - Creating Jobs","type":"extras","doc":"Jobs are simply modules with a perform method. With Oban we must add use Oban.Worker to our jobs with the relevant configuration. defmodule MyJob do use Oban.Worker, queue: &quot;events&quot;, max_attempts: 10 @impl Oban.Worker def perform(arg1, _job) do IO.inspect(arg1) end end"},{"ref":"readme.html#enqueuing-jobs","title":"GenQueue Oban - Enqueuing Jobs","type":"extras","doc":"We can now easily enqueue jobs to Oban. The adapter will handle a variety of argument formats. # Please note that zero-arg jobs default to using %{}, as per Oban requirements. # Push MyJob to your default queue with %{} arg. {:ok, job} = Enqueuer.push(MyJob) # Push MyJob to your default queue with %{} arg. {:ok, job} = Enqueuer.push({MyJob}) # Push MyJob to your default queue with %{&quot;foo&quot; =&gt; &quot;bar&quot;} arg. {:ok, job} = Enqueuer.push({MyJob, %{&quot;foo&quot; =&gt; &quot;bar&quot;}}) # Push MyJob to &quot;default&quot; queue with %{} arg. {:ok, job} = Enqueuer.push({MyJob, []}) # Push MyJob to &quot;default&quot; queue with %{&quot;foo&quot; =&gt; &quot;bar&quot;} arg. {:ok, job} = Enqueuer.push({MyJob, [%{&quot;foo&quot; =&gt; &quot;bar&quot;}]}) # Push MyJob to &quot;foo&quot; queue with %{&quot;foo&quot; =&gt; &quot;bar&quot;} arg {:ok, job} = Enqueuer.push({MyJob, %{&quot;foo&quot; =&gt; &quot;bar&quot;}}, [queue: &quot;foo&quot;]) # Schedule MyJob to your default queue with %{&quot;foo&quot; =&gt; &quot;bar&quot;} arg in 10 seconds {:ok, job} = Enqueuer.push({MyJob, %{&quot;foo&quot; =&gt; &quot;bar&quot;}}, [delay: 10_000]) # Schedule MyJob to your default queue with %{&quot;foo&quot; =&gt; &quot;bar&quot;} arg at a specific time date = DateTime.utc_now() {:ok, job} = Enqueuer.push({MyJob, %{&quot;foo&quot; =&gt; &quot;bar&quot;}}, [delay: date])"},{"ref":"readme.html#testing","title":"GenQueue Oban - Testing","type":"extras","doc":"Optionally, we can also have our tests use the GenQueue.Adapters.MockJob adapter. config :my_app, Enqueuer, [ adapter: GenQueue.Adapters.MockJob ] This mock adapter uses the standard GenQueue.Test helpers to send the job payload back to the current processes mailbox (or another named process) instead of actually enqueuing the job to rabbitmq. defmodule MyJobTest do use ExUnit.Case, async: true import GenQueue.Test setup do setup_test_queue(Enqueuer) end test &quot;my enqueuer works&quot; do {:ok, _} = Enqueuer.push(Job) assert_receive(%GenQueue.Job{module: Job, args: []}) end end If your jobs are being enqueued outside of the current process, we can use named processes to recieve the job. This wont be async safe. import GenQueue.Test setup do setup_global_test_queue(Enqueuer, :my_process_name) end"}]